def line_tokens(line):
    return line.rstrip("\r\n").split("\t")

def tokens_to_line(tokens):
    return '\t'.join(map(str, tokens))

def StreamReader(stream, field_names=None):
    if field_names is None:
        header_line = stream.next()
        field_names = line_tokens(header_line)
    for line in stream:
        fields = line_tokens(line)
        yield dict(zip(field_names, fields))

def FileReader(filename, field_names=None):
    f = open(filename)
    for row in StreamReader(f, field_names):
        yield row
    f.close()

class StreamWriter:
    def __init__(self, stream, field_names=None):
        self.stream = stream
        self.field_names = field_names
        if self.field_names is not None:
            print >>self.stream, tokens_to_line(self.field_names)

    def write(self, row):
        if self.field_names is None:
            print >>self.stream, tokens_to_line(row)
        else:
            tokens = [row[name] for name in self.field_names]
            print >>self.stream, tokens_to_line(tokens)

class FileWriter:
    def __init__(self, filename, field_names=None):
        self.stream = open(filename, 'w')
        self.writer = StreamWriter(self.stream, field_names)

    def write(self, row):
        self.writer.write(row)

    def close(self):
        self.stream.close()
